unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, GraphBtn, ColorBtn,
  Ctrl3D, ProCtrls, Tools1, About, Spin;

type
  TBarFrm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ComboBox1: TComboBox;
    Image1: TImage;
    Button1: TButton3D;
    Button2: TButton3D;
    Button3: TButton3D;
    Button4: TButton3D;
    Button5: TButton3D;
    Button6: TButton3D;
    Button7: TButton3D;
    Button8: TButton3D;
    Button9: TButton3D;
    Button10: TButton3D;
    SwHiBtn: TSpeedButton;
    SetBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    InfoBtn: TSpeedButton;
    SpinButton1: TSpinButton;
    procedure FormCreate(Sender: TObject);
    procedure SetBar1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ButtonAllClick(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure AppActivate(Sender: TObject);
    procedure AppDeactivate(Sender: TObject);
    procedure SwHiBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure InfoBtnClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  protected
    procedure WMGetMinMaxInfo(var Message: TWMGetMinMaxInfo);
                                  message wm_GetMinMaxInfo;
  private
    procedure DoFileExecute(configNumber:Integer); {** new}
    { Private declarations }
  public
    TheButtons : Array[1..10] of TButton3D;
    { Public declarations }
  end;

var
  BarFrm: TBarFrm;

implementation

{$R *.DFM}
uses Config;

{Call procedure to launch programs and determines some behaviors of Bar}
procedure TBarFrm.DoFileExecute(configNumber:Integer);
var
   rc           : Integer;
   fName        : PChar;
   numbString,
   FileName,
   InitialDir   : String;
begin
  numbString := IntToStr(configNumber);
  FileName   := Tools1.Programs[configNumber];

  if FileName <> '' then
  begin
    InitialDir := ExtractFilePath(FileName);
    ExecuteFile(FileName,'',Initialdir, SW_SHOW);
    if Config.CfgFrm.CheckSmall.Checked = true then
    begin
      BarFrm.Height := 80;
      BarFrm.SwHiBtn.Glyph.LoadFromFile(Config.CfgFrm.EditDir.Text + '\show.bmp');
      BarFrm.SwHiBtn.Hint := 'Show Bar';
    end
    else begin
      BarFrm.Height := 270;
      BarFrm.SwHiBtn.Glyph.LoadFromFile(Config.CfgFrm.EditDir.Text + '\hide.bmp');
      BarFrm.SwHiBtn.Hint := 'Hide Bar';
    end;
    if Config.CfgFrm.CheckMin.Checked = true then
    BarFrm.WindowState := wsMinimized
    else
    BarFrm.WindowState := wsNormal;
  end;
end;

{Set Min and Max dimensions of MgBar}
procedure TBarFrm.WMGetMinMaxInfo(var Message: TWMGetMinMaxInfo);
begin
  with Message.MinMaxInfo^ do
  begin
    ptMaxTrackSize.X := 128;
    ptMaxTrackSize.Y := 270;
    ptMinTrackSize.X := 128;
    ptMinTrackSize.Y := 78;
  end;
end;

{initializes array of buttons, and call combobox items setting active item}
procedure TBarFrm.FormCreate(Sender: TObject);
begin
  Main.BarFrm.Height := 78;
  TheButtons[1]  := Button1;
  TheButtons[2]  := Button2;
  TheButtons[3]  := Button3;
  TheButtons[4]  := Button4;
  TheButtons[5]  := Button5;
  TheButtons[6]  := Button6;
  TheButtons[7]  := Button7;
  TheButtons[8]  := Button8;
  TheButtons[9]  := Button9;
  TheButtons[10] := Button10;
  ComboBox1.Items.LoadFromFile('Items.txt');
  ComboBox1.ItemIndex := 0;
  Application.OnIdle := AppIdle;
  Application.OnActivate := AppActivate;
  Application.OnDeactivate := AppDeactivate;
end;

{verifies if buttons captions must be uppercase and if there is a caption or not}
procedure TBarFrm.AppIdle(Sender: TObject; var Done: Boolean);
var
ix : Integer;
begin
  for ix := 1 to 10 do
  begin
    if Config.CfgFrm.CheckUppercase.Checked then
      TheButtons[ix].Caption := UpperCase(TheButtons[ix].caption);
    if TheButtons[iX].caption = '' then
      TheButtons[iX].caption := '?';
  end;
  Done := False;
end;

{set authomatic resize for onActivate event}
procedure TBarFrm.AppActivate(Sender: TObject);
begin
  if Config.CfgFrm.CheckResize.Checked then
  begin
    Main.BarFrm.Height := 270;
    SwHiBtn.Glyph.LoadFromFile(Config.CfgFrm.EditDir.Text + '\Hide.bmp');
    SwHiBtn.Hint := 'Hide Bar';
  end;
end;

{set authomatic resize for onDeactivate event}
procedure TBarFrm.AppDeactivate(Sender: TObject);
begin
  if Config.CfgFrm.CheckResize.Checked then
  begin
    Main.BarFrm.Height := 78;
    SwHiBtn.Glyph.LoadFromFile(Config.CfgFrm.EditDir.Text + '\Show.bmp');
    SwHiBtn.Hint := 'Show Bar';
  end;
end;

{verifies if MgBar knows its own directory in user's computer and accords
mainform combobox items with configform pages}
procedure TBarFrm.FormActivate(Sender: TObject);
begin
  if Config.CfgFrm.EditDir.Text = '' then
  begin
    Config.CfgFrm.Show;
    Config.CfgFrm.TabbedNotebook1.PageIndex := 0;
  end;

  case Config.CfgFrm.TabbedNotebook1.PageIndex of
    1 : ComboBox1.ItemIndex := 0;
    2 : ComboBox1.ItemIndex := 1;
    3 : ComboBox1.ItemIndex := 2;
    4 : ComboBox1.ItemIndex := 3;
    5 : ComboBox1.ItemIndex := 4;
    6 : ComboBox1.ItemIndex := 5;
    7 : ComboBox1.ItemIndex := 6;
    8 : ComboBox1.ItemIndex := 7;
    9 : ComboBox1.ItemIndex := 8;
    10 : ComboBox1.ItemIndex := 9;
  end;
  ComboBox1Change(Sender);
end;

procedure TBarFrm.SetBar1Click(Sender: TObject);
begin
  Config.CfgFrm.Show;
end;

procedure TBarFrm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TBarFrm.ComboBox1Change(Sender: TObject);
var
  tabOfset : Integer;
  ix       : Integer;
begin
  tabOfset := ComboBox1.ItemIndex * 10;
  for ix := 1 to 10 do
  begin
    TheButtons[iX].caption := Tools1.Captions[tabOfset+ix];
    TheButtons[iX].enabled := (Tools1.Programs[tabOfset+ix] <> '');
  end;
end;

procedure TBarFrm.ButtonAllClick(Sender: TObject);
begin
  doFileExecute(ComboBox1.ItemIndex * 10
                + TButton3D(Sender).Tag);
end;

procedure TBarFrm.ComboBox1Click(Sender: TObject);
begin
  Main.BarFrm.Height := 270;
  SwHiBtn.Glyph.LoadFromFile(Config.CfgFrm.EditDir.Text + '\Hide.bmp');
end;

{rules behavior of Show/Hide button}
procedure TBarFrm.SwHiBtnClick(Sender: TObject);
begin
  With TSpeedButton(Sender) do
  begin
    if Hint = 'Hide Bar' then
    begin
      BarFrm.Height := 78;
      Glyph.LoadFromFile(Config.CfgFrm.EditDir.Text + '\Show.bmp');
      Hint := 'Show Bar';
      if Config.CfgFrm.ComboBox3.ItemIndex = 1 then
        Main.BarFrm.Top := 495;
      if Config.CfgFrm.ComboBox3.ItemIndex = 2 then
        Main.BarFrm.Top := 269;
    end
    else begin
      BarFrm.Height := 270;
      Glyph.LoadFromFile(Config.CfgFrm.EditDir.Text + '\Hide.bmp');
      Hint := 'Hide Bar';
      if Config.CfgFrm.ComboBox3.ItemIndex = 1 then
        Main.BarFrm.Top := 305;
      if Config.CfgFrm.ComboBox3.ItemIndex = 2 then
        Main.BarFrm.Top := 162;
    end;
  end;
end;

procedure TBarFrm.HelpBtnClick(Sender: TObject);
begin
 Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TBarFrm.FormDestroy(Sender: TObject);
begin
  Application.HelpCommand(HELP_QUIT, 0);
end;

procedure TBarFrm.InfoBtnClick(Sender: TObject);
begin
  About.AboutBox.ShowModal;
end;

procedure TBarFrm.SpinButton1DownClick(Sender: TObject);
begin
  if ComboBox1.ItemIndex <> 9 then
    ComboBox1.ItemIndex := ComboBox1.ItemIndex + 1;
    ComboBox1Change(Sender);
end;

procedure TBarFrm.SpinButton1UpClick(Sender: TObject);
begin
  if ComboBox1.ItemIndex <> 0 then
  begin
    ComboBox1.ItemIndex := ComboBox1.ItemIndex - 1;
    ComboBox1Change(Sender);
  end;
end;

end.
